import { MediaPlayer } from './MediaPlayer';
export declare const FIND_PLAYER_EVENT = "vmFindPlayer";
export declare type FoundPlayerCallback = (player: HTMLVmPlayerElement) => void;
export declare function withFindPlayer(player: MediaPlayer): void;
/**
 * Finds the closest ancestor player element by firing the `vmFindPlayer` event, and waiting
 * for the player to catch it. This function retries finding the player (`maxRetries`) until it
 * gives up and fails.
 *
 * @param ref - A HTMLElement that is within the player's subtree.
 * @param interval - The length of the timeout before trying again in milliseconds.
 * @param maxRetries - The number of times to retry firing the event.
 */
export declare const findPlayer: (ref: unknown, interval?: number, maxRetries?: number) => Promise<HTMLVmPlayerElement | undefined>;
