/**
 * This component is a shorthand way to setup the entire default vime user interface, such as
 * controls, settings, captions and so on.
 *
 * ## Visuals
 *
 * There are also alternative interfaces for live media, and the light player theme, but they're not
 * shown here for the sake of brevity.
 *
 * ### Audio
 *
 * <img
 *   src="https://raw.githubusercontent.com/vime-js/vime/master/packages/core/src/components/ui/default-ui/default-ui--audio.png"
 *   alt="Vime default audio player"
 * />
 *
 * ### Desktop Video
 *
 * <img
 *   src="https://raw.githubusercontent.com/vime-js/vime/master/packages/core/src/components/ui/default-ui/default-ui--desktop.png"
 *   alt="Vime default desktop video player"
 * />
 *
 * ### Mobile Video
 *
 * <img
 *   src="https://raw.githubusercontent.com/vime-js/vime/master/packages/core/src/components/ui/default-ui/default-ui--mobile.png"
 *   alt="Vime default desktop mobile player"
 * />
 *
 * @slot - Used to extend the default user interface with custom UI components.
 */
export declare class DefaultUI {
  /**
   * Whether clicking the player should not toggle playback.
   */
  noClickToPlay: boolean;
  /**
   * Whether double clicking the player should not toggle fullscreen mode.
   */
  noDblClickFullscreen: boolean;
  /**
   * Whether the custom captions UI should not be loaded.
   */
  noCaptions: boolean;
  /**
   * Whether the custom poster UI should not be loaded.
   */
  noPoster: boolean;
  /**
   * Whether the custom spinner UI should not be loaded.
   */
  noSpinner: boolean;
  /**
   * Whether the custom default controls should not be loaded.
   */
  noControls: boolean;
  /**
   * Whether the custom default settings menu should not be loaded.
   */
  noSettings: boolean;
  /**
   * Whether the default loading screen should not be loaded.
   */
  noLoadingScreen: boolean;
  constructor();
  render(): any;
}
